//QuizClient.java: each QuizClient supplies data to a student performing a Quiz

import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;  //for class Vector

class QuizClient extends Thread {
   DataOutputStream output;
   DataInputStream input;
   QuizServer quizServer;
   Socket connection;
   int userIndex=-1;
   
   public QuizClient( Socket s, QuizServer server )
   { //Get input and output streams.   
     connection = s;
     quizServer = server;
     quizServer.display.append( "Connection received from: " +
                  connection.getInetAddress().getHostName() );
     try
     { 
        input = new DataInputStream( connection.getInputStream() );
        output = new DataOutputStream( connection.getOutputStream() );
     }
    catch ( IOException e ) 
    { System.out.println("QuizClient could not open streams through connection"); 
       e.printStackTrace(); 
    }
  }
  
  public void run() 
   {  
      String name=new String();
      quizServer.display.append("...running QuizClient connection...\n");
      try
       { //first, send passwords through connection
         output.writeUTF("\n"); //empty line         
         output.writeUTF("umachine\n");
         output.writeUTF("newbie\n");
         
         //Now read user's name
         boolean nameMatched=false;
         while (!nameMatched)
         { name = input.readUTF();  quizServer.display.append(name);
            if (name.startsWith("find="))
            { userIndex = quizServer.studentScores.studentNames.
                                      indexOf(name.substring(5));
               if (userIndex >= 0)  //found user's name in studentScores
               {  if (quizServer.studentScores.canAddScore( userIndex,quizServer.QuizNumber))
                  { output.writeUTF("ok\n");  nameMatched=true;  }
                  else
                  { output.writeUTF("taken\n"); nameMatched=false;
                    quizServer.display.append( name+" attempting to retake quiz...denied...\n" );
                  }
               }
               else output.writeUTF("no\n");
            }
            else  if (name.startsWith("new="))
            { userIndex =quizServer.studentScores.studentNames.indexOf(name.substring(4));
              if (userIndex == -1)  //shouldn't be in database already
              { userIndex = quizServer.studentScores.newStudent(name.substring(4));
                 output.writeUTF("ok\n");
                 nameMatched=true;                 
              }
              else output.writeUTF("no\n"); 
            }//else if
          quizServer.display.append(" userIndex="+userIndex+"\n");
        }//while (!nameMatched)
                    
          //Send quizLines through connection
         Enumeration q = quizServer.quizLines.elements();
         while (q.hasMoreElements())
          {
               String  line = (String)q.nextElement();
               output.writeUTF(line + " \n");
          }
                  
         //Get final score for this quiz and record it
         String score=input.readUTF();
         if (score.startsWith("score="))  
         { int scoreValue=new Integer(score.substring(6).trim()).intValue(); 
           quizServer.studentScores.addScore( userIndex,quizServer.QuizNumber,scoreValue );
         }
         else quizServer.display.append( "QuizClient expecting score, but got " + score+"\n" );
         
         //Update UMscores.bin file
         synchronized (quizServer.studentScores)  { quizServer.studentScores.writeFile(); }
         quizServer.display.append("Updated UMscores.bin for " + name +"\n");
           
          //Close this socket connection
          quizServer.display.append( "Closing a socket.\n" );
          connection.close();
       }
      catch ( IOException e ) 
      { System.out.println("QuizServer connection error"); 
        e.printStackTrace(); 
      }
   } //run()
}   //class QuizServer
